From 58df5a51b6fcf96ab8c233b956d12514b907de2e Mon Sep 17 00:00:00 2001
From: Holger Just <hjust@meine-er.de>
Date: Tue, 28 Aug 2012 17:03:55 +0200
Subject: Replace named_scope with class methods

--HG--
extra : source : 480e1bdb792adecf0e6c0d56e30f534db9e21d27
---
 app/models/changeset.rb                            |    5 +-
 app/models/document.rb                             |    5 +-
 app/models/enumeration.rb                          |    9 +++-
 app/models/issue.rb                                |   49 +++++++++++--------
 app/models/message.rb                              |    5 +-
 app/models/news.rb                                 |   16 +++---
 app/models/principal.rb                            |   14 +++--
 app/models/project.rb                              |   30 ++++++++----
 app/models/role.rb                                 |   15 ++++--
 app/models/time_entry.rb                           |    8 ++--
 app/models/user.rb                                 |   17 ++++---
 app/models/version.rb                              |   10 +++-
 app/models/wiki_page.rb                            |    8 ++--
 .../acts_as_watchable/lib/acts_as_watchable.rb     |   32 ++++++------
 14 files changed, 132 insertions(+), 91 deletions(-)

diff --git a/app/models/changeset.rb b/app/models/changeset.rb
index 3634ac1..5560611 100644
--- a/app/models/changeset.rb
+++ b/app/models/changeset.rb
@@ -37,8 +37,9 @@ class Changeset < ActiveRecord::Base
   validates_uniqueness_of :revision, :scope => :repository_id
   validates_uniqueness_of :scmid, :scope => :repository_id, :allow_nil => true
 
-  named_scope :visible, lambda {|*args| { :include => {:repository => :project},
-                                          :conditions => Project.allowed_to_condition(args.first || User.current, :view_changesets) } }
+  def self.visible(user=User.current)
+    joins(:repository => :project).where(Project.allowed_to_condition(user, :view_changesets))
+  end
 
   def revision=(r)
     write_attribute :revision, (r.nil? ? nil : r.to_s)
diff --git a/app/models/document.rb b/app/models/document.rb
index 07f9315..7d4d608 100644
--- a/app/models/document.rb
+++ b/app/models/document.rb
@@ -30,8 +30,9 @@ class Document < ActiveRecord::Base
   validates_presence_of :project, :title, :category
   validates_length_of :title, :maximum => 60
 
-  named_scope :visible, lambda {|*args| { :include => :project,
-                                          :conditions => Project.allowed_to_condition(args.first || User.current, :view_documents) } }
+  def self.visible(user=User.current)
+    joins(:project).where(Project.allowed_to_condition(user, :view_documents))
+  end
 
   safe_attributes 'category_id', 'title', 'description'
 
diff --git a/app/models/enumeration.rb b/app/models/enumeration.rb
index e58fb0e..f7fccab 100644
--- a/app/models/enumeration.rb
+++ b/app/models/enumeration.rb
@@ -27,8 +27,13 @@ class Enumeration < ActiveRecord::Base
   validates_uniqueness_of :name, :scope => [:type, :project_id]
   validates_length_of :name, :maximum => 30
 
-  named_scope :shared, :conditions => { :project_id => nil }
-  named_scope :active, :conditions => { :active => true }
+  def self.shared
+    where(:project_id => nil)
+  end
+
+  def self.active
+    where(:active => true)
+  end
 
   def self.default
     # Creates a fake default scope so Enumeration.default will check
diff --git a/app/models/issue.rb b/app/models/issue.rb
index d9047ae..adfcdac 100644
--- a/app/models/issue.rb
+++ b/app/models/issue.rb
@@ -66,27 +66,34 @@ class Issue < ActiveRecord::Base
   validates_inclusion_of :done_ratio, :in => 0..100
   validates_numericality_of :estimated_hours, :allow_nil => true
 
-  named_scope :visible, lambda {|*args| { :include => :project,
-                                          :conditions => Issue.visible_condition(args.first || User.current) } }
-
-  named_scope :open, :conditions => ["#{IssueStatus.table_name}.is_closed = ?", false], :include => :status
-
-  named_scope :recently_updated, :order => "#{Issue.table_name}.updated_on DESC"
-  named_scope :with_limit, lambda { |limit| { :limit => limit} }
-  named_scope :on_active_project, :include => [:status, :project, :tracker],
-                                  :conditions => ["#{Project.table_name}.status=#{Project::STATUS_ACTIVE}"]
-
-  named_scope :without_version, lambda {
-    {
-      :conditions => { :fixed_version_id => nil}
-    }
-  }
-
-  named_scope :with_query, lambda {|query|
-    {
-      :conditions => Query.merge_conditions(query.statement)
-    }
-  }
+  def self.visible(user=User.current)
+    joins(:project).where self.visible_condition(user)
+  end
+
+  def self.open
+    joins(:status).where(:status => {:is_closed => false})
+  end
+
+  def self.recently_updated
+    order("updated_on DESC")
+  end
+
+  def self.with_limit(limit)
+    ActiveSupport::Deprecation.warn "with_limit is deprecated. Use limit instead."
+    self.limit(limit)
+  end
+
+  def self.on_active_project
+    joins(:project).where(:project => {:status => Project::STATUS_ACTIVE})
+  end
+
+  def self.without_version
+    where(:fixed_version_id => nil)
+  end
+
+  def self.with_query(query)
+    where(Query.merge_conditions(query.statement))
+  end
 
   before_create :default_assign
   before_save :close_duplicates, :update_done_ratio_from_issue_status
diff --git a/app/models/message.rb b/app/models/message.rb
index 441756c..311f4e9 100644
--- a/app/models/message.rb
+++ b/app/models/message.rb
@@ -46,8 +46,9 @@ class Message < ActiveRecord::Base
 
   after_create :add_author_as_watcher
 
-  named_scope :visible, lambda {|*args| { :include => {:board => :project},
-                                          :conditions => Project.allowed_to_condition(args.first || User.current, :view_messages) } }
+  def self.visible(user=User.current)
+    joins(:board => :project).where(Project.allowed_to_condition(user, :view_messages))
+  end
 
   safe_attributes 'subject', 'content'
   safe_attributes 'locked', 'sticky', 'board_id',
diff --git a/app/models/news.rb b/app/models/news.rb
index dc62e96..f4eeac1 100644
--- a/app/models/news.rb
+++ b/app/models/news.rb
@@ -29,10 +29,14 @@ class News < ActiveRecord::Base
 
   after_create :add_author_as_watcher
 
-  named_scope :visible, lambda {|*args| {
-    :include => :project,
-    :conditions => Project.allowed_to_condition(args.first || User.current, :view_news)
-  }}
+  def self.visible(user=User.current)
+    joins(:project).where(Project.allowed_to_condition(user, :view_news))
+  end
+
+  # returns latest news for projects visible by user
+  def self.latest(user=User.current, count=5)
+    visible.joins(:author).limit(count).order('created_on DESC')
+  end
 
   safe_attributes 'title', 'summary', 'description'
 
@@ -45,10 +49,6 @@ class News < ActiveRecord::Base
     user.allowed_to?(:comment_news, project)
   end
 
-  # returns latest news for projects visible by user
-  def self.latest(user = User.current, count = 5)
-    find(:all, :limit => count, :conditions => Project.allowed_to_condition(user, :view_news), :include => [ :author, :project ], :order => "#{News.table_name}.created_on DESC")
-  end
 
   private
 
diff --git a/app/models/principal.rb b/app/models/principal.rb
index b239fa8..ae2c5dc 100644
--- a/app/models/principal.rb
+++ b/app/models/principal.rb
@@ -20,14 +20,16 @@ class Principal < ActiveRecord::Base
   has_many :projects, :through => :memberships
 
   # Groups and active users
-  named_scope :active, :conditions => "#{Principal.table_name}.type='Group' OR (#{Principal.table_name}.type='User' AND #{Principal.table_name}.status = 1)"
+  def self.active
+    where(['(type = ? OR type = ?) AND status = ?', 'Group', 'User', 1])
+  end
 
-  named_scope :like, lambda {|q|
+  def self.like(q)
     s = "%#{q.to_s.strip.downcase}%"
-    {:conditions => ["LOWER(login) LIKE :s OR LOWER(firstname) LIKE :s OR LOWER(lastname) LIKE :s OR LOWER(mail) LIKE :s", {:s => s}],
-     :order => 'type, login, lastname, firstname, mail'
-    }
-  }
+
+    where(["LOWER(login) LIKE :s OR LOWER(firstname) LIKE :s OR LOWER(lastname) LIKE :s OR LOWER(mail) LIKE :s", {:s => s}]).
+    order('type, login, lastname, firstname, mail')
+  end
 
   before_create :set_default_empty_values
 
diff --git a/app/models/project.rb b/app/models/project.rb
index 0efaf35..3284ec4 100644
--- a/app/models/project.rb
+++ b/app/models/project.rb
@@ -78,16 +78,28 @@ class Project < ActiveRecord::Base
 
   before_destroy :delete_all_members
 
-  named_scope :has_module, lambda { |mod| { :conditions => ["#{Project.table_name}.id IN (SELECT em.project_id FROM #{EnabledModule.table_name} em WHERE em.name=?)", mod.to_s] } }
-  named_scope :active, { :conditions => "#{Project.table_name}.status = #{STATUS_ACTIVE}"}
-  named_scope :all_public, { :conditions => { :is_public => true } }
-  named_scope :visible, lambda { { :conditions => Project.visible_by(User.current) } }
-  named_scope :like, lambda {|q|
+  def self.has_module(mod)
+    joins(:enabled_modules).where(:enabled_modules => {:name => mod.to_s})
+  end
+
+  def self.active
+    where(:status => STATUS_ACTIVE)
+  end
+
+  def self.all_public
+    where(:is_public => true)
+  end
+
+  def self.visible
+    # TODO: merge visible and visible_by
+    where(visible_by(User.current))
+  end
+
+  def self.like(q)
     s = "%#{q.to_s.strip.downcase}%"
-    {
-      :conditions => ["LOWER(name) LIKE ?", s]
-    }
-  }
+
+    where(["LOWER(name) LIKE ?", s])
+  end
 
   def to_liquid
     ProjectDrop.new(self)
diff --git a/app/models/role.rb b/app/models/role.rb
index bd8a23d..cfbe127 100644
--- a/app/models/role.rb
+++ b/app/models/role.rb
@@ -17,11 +17,16 @@ class Role < ActiveRecord::Base
   BUILTIN_NON_MEMBER = 1
   BUILTIN_ANONYMOUS  = 2
 
-  named_scope :givable, { :conditions => "builtin = 0", :order => 'position' }
-  named_scope :builtin, lambda { |*args|
-    compare = 'not' if args.first == true
-    { :conditions => "#{compare} builtin = 0" }
-  }
+  def self.givable
+    where(:builtin => 0).order('position ASC')
+  end
+
+  def self.builtin(negate=false)
+    # TODO: Isn't that the wrong way
+    # TODO: Do we even need this here?
+    compare = (negate == true ? 'not' : '')
+    where("#{compare} builtin = 0")
+  end
 
   before_destroy :check_deletable
   has_many :workflows, :dependent => :delete_all do
diff --git a/app/models/time_entry.rb b/app/models/time_entry.rb
index 4bb557b..444493d 100644
--- a/app/models/time_entry.rb
+++ b/app/models/time_entry.rb
@@ -33,10 +33,9 @@ class TimeEntry < ActiveRecord::Base
   validates_numericality_of :hours, :allow_nil => true, :message => :invalid
   validates_length_of :comments, :maximum => 255, :allow_nil => true
 
-  named_scope :visible, lambda {|*args| {
-    :include => :project,
-    :conditions => Project.allowed_to_condition(args.first || User.current, :view_time_entries)
-  }}
+  def self.visible(user=User.current)
+    joins(:project).where(Project.allowed_to_condition(user, :view_time_entries))
+  end
 
   safe_attributes 'hours', 'comments', 'issue_id', 'activity_id', 'spent_on', 'custom_field_values'
 
@@ -88,6 +87,7 @@ class TimeEntry < ActiveRecord::Base
     end
   end
 
+  # FIXME: Typo in method name
   def self.earilest_date_for_project(project=nil)
     finder_conditions = ARCondition.new(Project.allowed_to_condition(User.current, :view_time_entries))
     if project
diff --git a/app/models/user.rb b/app/models/user.rb
index cff63e0..3218cbc 100644
--- a/app/models/user.rb
+++ b/app/models/user.rb
@@ -50,7 +50,9 @@ class User < Principal
   belongs_to :auth_source
 
   # Active non-anonymous users scope
-  named_scope :active, :conditions => "#{User.table_name}.status = #{STATUS_ACTIVE}"
+  def self.active
+    where(:status => STATUS_ACTIVE)
+  end
 
   acts_as_customizable
 
@@ -71,14 +73,15 @@ class User < Principal
   validates_inclusion_of :mail_notification, :in => MAIL_NOTIFICATION_OPTIONS.collect(&:first), :allow_blank => true
   validates_inclusion_of :status, :in => [STATUS_ANONYMOUS, STATUS_ACTIVE, STATUS_REGISTERED, STATUS_LOCKED]
 
-  named_scope :in_group, lambda {|group|
+  def self.in_group(group)
     group_id = group.is_a?(Group) ? group.id : group.to_i
-    { :conditions => ["#{User.table_name}.id IN (SELECT gu.user_id FROM #{table_name_prefix}groups_users#{table_name_suffix} gu WHERE gu.group_id = ?)", group_id] }
-  }
-  named_scope :not_in_group, lambda {|group|
+    joins(:groups).where(:groups => {:group_id => group_id})
+  end
+
+  def self.not_in_group(group)
     group_id = group.is_a?(Group) ? group.id : group.to_i
-    { :conditions => ["#{User.table_name}.id NOT IN (SELECT gu.user_id FROM #{table_name_prefix}groups_users#{table_name_suffix} gu WHERE gu.group_id = ?)", group_id] }
-  }
+    joins(:groups).where(:groups => ["group_id != ?", group_id])
+  end
 
   def before_create
     self.mail_notification = Setting.default_notification_option if self.mail_notification.blank?
diff --git a/app/models/version.rb b/app/models/version.rb
index ba936d5..96b8a61 100644
--- a/app/models/version.rb
+++ b/app/models/version.rb
@@ -31,9 +31,13 @@ class Version < ActiveRecord::Base
   validates_inclusion_of :status, :in => VERSION_STATUSES
   validates_inclusion_of :sharing, :in => VERSION_SHARINGS
 
-  named_scope :open, :conditions => {:status => 'open'}
-  named_scope :visible, lambda {|*args| { :include => :project,
-                                          :conditions => Project.allowed_to_condition(args.first || User.current, :view_issues) } }
+  def self.open
+    where(:status => 'open')
+  end
+
+  def self.visible(user=User.current)
+    joins(:project).where(Project.allowed_to_condition(user, :view_issues))
+  end
 
   safe_attributes 'name',
     'description',
diff --git a/app/models/wiki_page.rb b/app/models/wiki_page.rb
index 38c83cb..28664c1 100644
--- a/app/models/wiki_page.rb
+++ b/app/models/wiki_page.rb
@@ -39,10 +39,10 @@ class WikiPage < ActiveRecord::Base
   validates_associated :content
 
   # eager load information about last updates, without loading text
-  named_scope :with_updated_on, {
-    :select => "#{WikiPage.table_name}.*, #{WikiContent.table_name}.updated_on",
-    :joins => "LEFT JOIN #{WikiContent.table_name} ON #{WikiContent.table_name}.page_id = #{WikiPage.table_name}.id"
-  }
+  def self.with_updated_on
+    select("#{WikiPage.table_name}.*, #{WikiContent.table_name}.updated_on").
+    joins("LEFT JOIN #{WikiContent.table_name} ON #{WikiContent.table_name}.page_id = #{WikiPage.table_name}.id")
+  end
 
   # Wiki pages that are protected by default
   DEFAULT_PROTECTED_PAGES = %w(sidebar)
